﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ConsoleApplication1
{
    public class Farm : IFarm
    {
        private IList<IFarmRow> farmRows = new List<IFarmRow>();
        private string[] farmString;

        public Farm(string[] farmStrings)
        {
            this.FarmString = farmStrings;
        }

        #region IFarm Members


        public string[] FarmString
        {
            get
            {
                return farmString;
            }
            set
            {
                farmString = value;
                for (int i = 0; i < value.Length; i++)
                {
                    string currentRowString = value[i];

                    IFarmRow farmRow = new FarmRow(currentRowString, this);                   
                }
            }
        }

        public IFarmRow this[int xIndex]
        {
            get
            {
                if (xIndex > farmRows.Count)
                {
                    throw new IndexOutOfRangeException();
                }
                else
                {
                    return farmRows[xIndex];
                }
            }
            set
            {
                if (xIndex < farmRows.Count)
                {
                    farmRows[xIndex] = value;
                }
                else
                {
                    throw new IndexOutOfRangeException();
                }
            }
        }

        public void AddRow(IFarmRow row)
        {
            farmRows.Add(row);
        }

        public int RowCount
        {
            get
            {
                return farmRows.Count;
            }
        }

        public int ColumnCount
        {
            get
            {
                return farmRows[0].ColumnCount;
            }
        }

        public int GetCellCountSpecialNumBetween(int A, int B)
        {
            int result = 0;
            foreach (IFarmRow row in this)
            {
                foreach (ICell cell in row)
                {
                    if (cell.SpecialNumber >= A && cell.SpecialNumber <= B)
                    {
                        result += 1;
                    }
                }
            }
            return result;
        }

        #endregion

        #region IEnumerable<IFarmRow> Members

        public IEnumerator<IFarmRow> GetEnumerator()
        {
            return new FarmEnum(farmRows);
        }

        #endregion

        #region IEnumerable Members

        System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator()
        {
            return new FarmEnum(farmRows);
        }

        #endregion
    }
}
